@echo off

ver | find "version 10" > NUL && set "WINDOWS10=1" || set "WINDOWS10=0"
ver | find "XP" > NUL && set "WINDOWSXP=1" || set "WINDOWSXP=0"

set "SCRIPTDIR=%~p0"

if "%PATH:cygwin=%" == "%PATH%"  goto 1
echo Si vous utilisez ce script avec un terminal Cygwin ou MSYS/MinGW vous devriez quitter
echo et utiliser directement une invite de commandes Windows.
echo Quitter ? (o/n)
:0
set /p REPONSE=
if "%REPONSE%" == "o" exit /B
if not "%REPONSE%" == "n" echo repondre par 'o' ou par 'n' (sans les guillemets!) & goto 0
:1

set PATH=C:\windows\system32;C:\windows
 
reg Query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set "OSSIZE=32" || set "OSSIZE=64"

set TARGETOSSIZE=%OSSIZE%

set CYGWIN32PATH=C:\cygwin
set CYGWIN64PATH=C:\cygwin64

echo.

if %OSSIZE% == 64 (
	echo OCaml pour Windows
	echo Choix entre:

	echo 1 : Natif Microsoft  - 32 bits - OCaml 3.11.0 et suivants 
	echo 2 : Natif Microsoft  - 64 bits - OCaml 3.11.0 et suivants 

	echo 3 : Natif Mingw-w64  - 32 bits - OCaml 4.00.0 et suivants 
	echo 4 : Natif Mingw-w64  - 64 bits - OCaml 4.00.0 et suivants

	echo 5 : Cygwin           - 32 bits - OCaml 3.11.0 et suivants
	echo 6 : Cygwin           - 64 bits - OCaml 4.02.2 et suivants
)

if %OSSIZE% == 32 (
	echo OCaml pour Windows
	echo Choix entre:

	echo 1 : Natif Microsoft  - 32 bits - OCaml 3.11.0 et suivants 
	echo 2 : Natif Mingw-w64  - 32 bits - OCaml 4.00.0 et suivants 
	echo 3 : Cygwin           - 32 bits - OCaml 3.11.0 et suivants
)

if %OSSIZE% == 32 goto loop32

:loop64
	echo Entrer le chiffre 1, 2, 3, 4, 5, 6 , ou 0 pour quitter:
	set /p OPTION=
	if "%OPTION%" == "0" exit /B
	if not "%OPTION%" == "1" if not "%OPTION%" == "2" if not "%OPTION%" == "3" if not "%OPTION%" == "4" if not "%OPTION%" == "5" if not "%OPTION%" == "6" (
		echo choix invalide
		goto loop64
	)
	if not "%OPTION%" == "2" if not "%OPTION%" == "4" if not "%OPTION%" == "6" set TARGETOSSIZE=32
	goto loopend

:loop32
	echo Entrer le chiffre 1, 2, 3, ou 0 pour quitter:
	set /p OPTION=
	if "%OPTION%" == "0" exit /B
	if not "%OPTION%" == "1" if not "%OPTION%" == "2" if not "%OPTION%" == "3" (
		echo choix invalide
		goto loop32
	)
	if "%OPTION%" == "3" set "OPTION=5"
	if "%OPTION%" == "2" set "OPTION=3"

:loopend

set UNAME=CYGWIN

if "%OSSIZE%" == "64" (
	if "%OPTION%" == "6" (
		set CYGWINPATH=%CYGWIN64PATH%
		if not exist %CYGWIN64PATH% (
			echo Installer Cygwin64, puis lancer le terminal Cygwin64 et le quitter.
			echo Pour installer Cygwin64 utiliser le programme setup-x86_64 du site http://cygwin.com
		)
	) else (
		if "%OPTION%" == "5" (
			set CYGWINPATH=%CYGWIN32PATH%
			if not exist %CYGWIN32PATH% (
				echo Installer Cygwin, puis lancer le terminal Cygwin et le quitter.
				echo Pour installer Cygwin utiliser le programme setup-x86 du site http://cygwin.com
			)
		) else (
			if exist %CYGWIN64PATH% (
				set CYGWINPATH=%CYGWIN64PATH%
			) else if exist %CYGWIN32PATH% (
				set CYGWINPATH=%CYGWIN32PATH%
				echo.
				echo Cygwin - 32 bits - etant seul present sur cet machine 64 bits, il va etre utilise.
				echo En cas de d'echec, installer Cygwin64, puis lancer le terminal Cygwin64 et le quitter.
				echo Pour installer Cygwin64 utiliser le programme setup-x86_64.exe du site http://cygwin.com
				echo.
			) else (
				set CYGWINPATH=%CYGWIN64PATH%
				echo Installer Cygwin64, puis lancer le terminal Cygwin64 et le quitter.
				echo Pour installer Cygwin64 utiliser le programme setup-x86_64 du site http://cygwin.com 
			)
		)
	)
) else (
	set CYGWINPATH=%CYGWIN32PATH%
	if not exist %CYGWIN32PATH% (
		echo Installer Cygwin, puis lancer le terminal Cygwin et le quitter.
		echo Utiliser le programme setup-x86 du site http://cygwin.com
	)	
)

set "QUIT=0"

if "%CYGWINPATH%" == "%CYGWIN32PATH%" (
	if "%OPTION%" == "3" if not exist %CYGWINPATH%\bin\i686-w64-mingw32-gcc.exe echo Installer le paquet mingw64-i686-gcc-core de Cygwin & set "QUIT=1"
	if "%OPTION%" == "4" if not exist %CYGWINPATH%\bin\x86_64-w64-mingw32-gcc.exe echo Installer le paquet mingw64-x86_64-gcc-core de Cygwin & set "QUIT=1"
	if "%OPTION%" == "5" if not exist %CYGWINPATH%\bin\i686-pc-cygwin-gcc.exe echo Installer le paquet gcc-core de Cygwin & set "QUIT=1" 
	if "%OPTION%" == "5" if not exist %CYGWINPATH%\bin\dos2unix.exe echo Installer le paquet dos2unix de Cygwin & set "QUIT=1" 
	if "%OPTION%" == "5" if not exist %CYGWINPATH%\lib\flexdll echo Installer le paquet flexdll version 0.35 ou plus de Cygwin & set "QUIT=1" 
	if not exist %CYGWINPATH%\bin\tar.exe echo Installer le paquet tar de Cygwin & set "QUIT=1"
	if not exist %CYGWINPATH%\bin\make.exe echo Installer le paquet make de Cygwin & set "QUIT=1"
	if not exist %CYGWINPATH%\bin\diff.exe echo Installer le paquet diffutils de Cygwin & set "QUIT=1"
) else (
	if "%OPTION%" == "3" if not exist %CYGWINPATH%\bin\i686-w64-mingw32-gcc.exe echo Installer le paquet mingw64-i686-gcc-core de Cygwin64 & set "QUIT=2"
	if "%OPTION%" == "4" if not exist %CYGWINPATH%\bin\x86_64-w64-mingw32-gcc.exe echo Installer le paquet mingw64-x86_64-gcc-core de Cygwin64 & set "QUIT=2"
	if "%OPTION%" == "6" if not exist %CYGWINPATH%\bin\x86_64-pc-cygwin-gcc.exe echo Installer le paquet gcc-core de Cygwin64 & set "QUIT=2"
	if "%OPTION%" == "6" if not exist %CYGWINPATH%\bin\dos2unix.exe echo Installer le paquet dos2unix de Cygwin64 & set "QUIT=2" 
	if "%OPTION%" == "6" if not exist %CYGWINPATH%\lib\flexdll echo Installer le paquet flexdll version 0.35 ou plus de Cygwin64 & set "QUIT=2" 
	if not exist %CYGWINPATH%\bin\tar.exe echo Installer le paquet tar de Cygwin64 & set "QUIT=2"
	if not exist %CYGWINPATH%\bin\make.exe echo Installer le paquet make de Cygwin64 & set "QUIT=2"
	if not exist %CYGWINPATH%\bin\diff.exe echo Installer le paquet diffutils de Cygwin64 & set "QUIT=2"
)

if "%QUIT%" == "1" echo Utiliser pour cela le programme setup-x86.exe du site http://cygwin.com & goto fin
if "%QUIT%" == "2" echo Utiliser pour cela le programme setup-x86_64.exe du site http://cygwin.com & goto fin

PATH=%CYGWINPATH%\bin;C:\windows\system32;C:\windows

echo CYGWINPATH : %CYGWINPATH%

if not "%SCRIPTDIR%" == "%cd%" cd "%SCRIPTDIR%"
set "CYGDRIVE=/cygdrive"
%CYGWINPATH%\bin\bash build
set PATH=C:\windows\system32;C:\windows
:fin
echo.
echo Appuyer sur une touche pour terminer...
pause > nul
